unit FMXWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, Outline, DirOutln, Tabs, ExtCtrls, Menus,
  Buttons,ShellApi,UResGlob,UCreare;

type
  TFMForm = class(TForm)
    StatusBar: TPanel;
    DirectoryPanel: TPanel;
    FilePanel: TPanel;
    DriveTabSet: TTabSet;
    DirectoryOutline: TDirectoryOutline;
    FileList: TFileListBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Move1: TMenuItem;
    Copy1: TMenuItem;
    Delete1: TMenuItem;
    Rename1: TMenuItem;
    Properties1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Floppy: TImage;
    Fixed: TImage;
    Network: TImage;
    CDRom: TImage;
    RamDisk: TImage;
    Despre1: TMenuItem;
    Autor1: TMenuItem;
    Aplicatie1: TMenuItem;
    Creeazadirectornou1: TMenuItem;
    BitBtn1: TBitBtn;
    Vizualizare1: TMenuItem;
    Colturirotunjite1: TMenuItem;
    Stergedirector1: TMenuItem;
    Unelte1: TMenuItem;
    Editeazafisier1: TMenuItem;
    Editorimagini1: TMenuItem;
    Se1: TMenuItem;
    ExploratorInternet1: TMenuItem;
    Impacheteazafisier1: TMenuItem;
    Despacheteazafisier1: TMenuItem;
    Copieremultipla1: TMenuItem;
    Copieredirector1: TMenuItem;
    Stergeredirector1: TMenuItem;
    Mutaredirector1: TMenuItem;
    Redenumiredirector1: TMenuItem;
    Alteunelte1: TMenuItem;
    Split1: TMenuItem;
    Combina1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirectoryOutlineChange(Sender: TObject);
    procedure FileListChange(Sender: TObject);
    procedure DriveTabSetMeasureTab(Sender: TObject; Index: Integer;
      var TabWidth: Integer);
    procedure DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas;
      R: TRect; Index: Integer; Selected: Boolean);
    procedure File1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure FileChange(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FileListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DirectoryOutlineDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure DirectoryOutlineDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure DriveTabSetChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Autor1Click(Sender: TObject);
    procedure Aplicatie1Click(Sender: TObject);
    procedure Creeazadirectornou1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Colturirotunjite1Click(Sender: TObject);
    procedure Colturinormale1Click(Sender: TObject);
    procedure Stergedirector1Click(Sender: TObject);
    procedure Editeazafisier1Click(Sender: TObject);
    procedure Editorimagini1Click(Sender: TObject);
    procedure ExploratorInternet1Click(Sender: TObject);
    procedure Se1Click(Sender: TObject);
    procedure Impacheteazafisier1Click(Sender: TObject);
    procedure Despacheteazafisier1Click(Sender: TObject);
    procedure FileListDblClick(Sender: TObject);
    procedure Copieremultipla1Click(Sender: TObject);
    procedure FileListKeyPress(Sender: TObject; var Key: Char);
    procedure FileListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FileListClick(Sender: TObject);
    procedure FileListEnter(Sender: TObject);
    procedure Copieredirector1Click(Sender: TObject);
    procedure Stergeredirector1Click(Sender: TObject);
    procedure Mutaredirector1Click(Sender: TObject);
    procedure Redenumiredirector1Click(Sender: TObject);
    procedure Split1Click(Sender: TObject);
    procedure Combina1Click(Sender: TObject);
    //procedure CopyDirectoryTree(AHandle: THandle; const AFromDirectory, AToDirectory: String);
  private
    procedure ConfirmChange(const ACaption, FromFile, ToFile: string);
  public
    { Public declarations }
  end;

var
  FMForm: TFMForm;
  combina_ok:boolean;
implementation

uses FmxUtils, FAttrDlg, FChngDlg, UAbout1, UAbout, USetari, UStergere,
  UDesp, UCopiMult, UCopiDir, UStergArb, UMutaDir, URedenDir, USplit;

{$R *.dfm}

procedure TFMForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFMForm.FormCreate(Sender: TObject);
var
  Drive: Char;
  AddedIndex: Integer;
begin
  cale_paint:='mspaint';
  cale_notepad:='notepad';
  cale_exec:='d:\so\wincom.exe';
  cale_explorer:='c:\program files\Internet Explorer\iexplore.exe';
  cale_arhiv:='d:\temp\rar.exe';
  cale_pt_arhiv:='d:\temp\arhfman.rar';
  cale_dezarhiv:='d:\temp\unrar.exe';
  con_fis:=0;
  indice:=-1;
  combina_ok:=true;
  for Drive := 'a' to 'z' do
  begin
    case GetDriveType(PChar(Drive + ':\')) of
      DRIVE_REMOVABLE:
        AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Floppy.Picture.Graphic);
      DRIVE_FIXED:
        AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Fixed.Picture.Graphic);
      DRIVE_CDROM:
        AddedIndex := DriveTabSet.Tabs.AddObject(Drive, CDRom.Picture.Graphic);
      DRIVE_RAMDISK:
        AddedIndex := DriveTabSet.Tabs.AddObject(Drive, RamDisk.Picture.Graphic);
      DRIVE_REMOTE:
        AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Network.Picture.Graphic);
    else
      AddedIndex := 0;
    end;
    if UpCase(Drive) = FileList.Drive then
      DriveTabSet.TabIndex := AddedIndex;
  end;
end;

procedure TFMForm.DriveTabSetChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if not (csDesigning in ComponentState) then
  begin
    AllowChange := True;
    try
      with DriveTabSet do
        DirectoryOutline.Drive := Tabs[NewTab][1];
    except
      on EInOutError do
      begin
        AllowChange := False;
        with DriveTabSet do
          DirectoryOutline.Drive := Tabs[TabIndex][1];
        raise;
      end;
    end;
  end;
end;

procedure TFMForm.DirectoryOutlineChange(Sender: TObject);
begin
  FileList.Directory := DirectoryOutline.Directory;
  DirectoryPanel.Caption := DirectoryOutline.Directory;
end;

procedure TFMForm.FileListChange(Sender: TObject);
var
  TheFileName: string;
begin
  with FileList do
  begin
    if ItemIndex >= 0 then
    begin
      TheFileName := Items[ItemIndex];
      FilePanel.Caption := Format('%s, %d octeti', [TheFileName, GetFileSize(TheFileName)]);
    end
    else FilePanel.Caption := '';
  end;
end;

procedure TFMForm.DriveTabSetMeasureTab(Sender: TObject; Index: Integer;
  var TabWidth: Integer);
var
  BitmapWidth: Integer;
begin
  BitmapWidth := TBitmap(DriveTabSet.Tabs.Objects[Index]).Width;
  Inc(TabWidth, 2 + BitmapWidth);
end;

procedure TFMForm.DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas;
  R: TRect; Index: Integer; Selected: Boolean);
var
  Bitmap: TBitmap;
begin
  Bitmap := TBitmap(DriveTabSet.Tabs.Objects[Index]);
  with TabCanvas do
  begin
    Draw(R.Left, R.Top + 4, Bitmap);
    TextOut(R.Left + 2 + Bitmap.Width, R.Top + 2, DriveTabSet.Tabs[Index]);
  end;
end;

procedure TFMForm.File1Click(Sender: TObject);
var
  FileSelected: Boolean;
begin
  FileSelected := FileList.ItemIndex >= 0;
  Open1.Enabled := FileSelected;
  Delete1.Enabled := FileSelected;
  Copy1.Enabled := FileSelected;
  Move1.Enabled := FileSelected;
  Rename1.Enabled := FileSelected;
  Properties1.Enabled := FileSelected;
end;

procedure TFMForm.Delete1Click(Sender: TObject);
begin
  with FileList do
    if MessageDlg('Sterge ' + FileName + '?', mtConfirmation,
      [mbYes, mbNo], 0) = mrYes then
      if DeleteFile(FileName) then Update;
end;

procedure TFMForm.Properties1Click(Sender: TObject);
var
  Attributes, NewAttributes: Word;
begin
  with FileAttrForm do
  begin
    FileDirName.Caption := FileList.Items[FileList.ItemIndex];
    FilePathName.Caption := FileList.Directory;
    ChangeDate.Caption := DateTimeToStr(FileDateTime(FileList.FileName));
    Attributes := FileGetAttr(FileDirName.Caption);
    ReadOnly.Checked := (Attributes and faReadOnly) = faReadOnly;
    Archive.Checked := (Attributes and faArchive) = faArchive;
    System.Checked := (Attributes and faSysFile) = faSysFile;
    Hidden.Checked := (Attributes and faHidden) = faHidden;
    if ShowModal <> mrCancel then
    begin
      NewAttributes := Attributes;
      if ReadOnly.Checked then NewAttributes := NewAttributes or faReadOnly
      else NewAttributes := NewAttributes and not faReadOnly;
      if Archive.Checked then NewAttributes := NewAttributes or faArchive
      else NewAttributes := NewAttributes and not faArchive;
      if System.Checked then NewAttributes := NewAttributes or faSysFile
      else NewAttributes := NewAttributes and not faSysFile;
      if Hidden.Checked then NewAttributes := NewAttributes or faHidden
      else NewAttributes := NewAttributes and not faHidden;
      if NewAttributes <> Attributes then
        FileSetAttr(FileDirName.Caption, NewAttributes);
    end;
  end;
end;

procedure TFMForm.ConfirmChange(const ACaption, FromFile, ToFile: string);
begin
  if MessageDlg(Format('%s %s to %s?', [ACaption, FromFile, ToFile]),
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if ACaption = 'Muta' then
      MoveFile(FromFile, ToFile)
    else if ACaption = 'Copiaza' then
      CopyFile(FromFile, ToFile)
    else if ACaption = 'Redenumeste' then
      RenameFile(FromFile, ToFile);
    FileList.Update;
  end;
end;

procedure TFMForm.FileChange(Sender: TObject);
begin
  with ChangeDlg do
  begin
    if Sender = Move1 then Caption := 'Muta'
    else if Sender = Copy1 then Caption := 'Copiaza'
    else if Sender = Rename1 then Caption := 'Redenumeste'
    else Exit;
    CurrentDir.Caption := DirectoryOutline.Directory;
    FromFileName.Text := FileList.FileName;
    ToFileName.Text := '';
    if (ShowModal <> mrCancel) and (ToFileName.Text <> '') then
      ConfirmChange(Caption, FromFileName.Text, ToFileName.Text);
  end;
end;

procedure TFMForm.Open1Click(Sender: TObject);
begin
  with FileList do
  begin
    if HasAttr(FileName, faDirectory) then
      DirectoryOutline.Directory := FileName
    else ExecuteFile(FileName, '', Directory, SW_SHOW);
  end;
end;

procedure TFMForm.FileListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  with Sender as TFileListBox do
  begin
    if ItemAtPos(Point(X, Y), True) >= 0 then
      BeginDrag(False);
  end;
end;

procedure TFMForm.DirectoryOutlineDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TFileListBox) and (DirectoryOutline.GetItem(X, Y) > 0);
end;

procedure TFMForm.DirectoryOutlineDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source is TFileListBox then
    with DirectoryOutline do
      ConfirmChange('Muta', FileList.FileName, Items[GetItem(X, Y)].FullPath);
end;

procedure TFMForm.FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  if Target <> nil then FileList.Update;
end;

procedure TFMForm.Autor1Click(Sender: TObject);
begin
  AboutBox.show;
end;

procedure TFMForm.Aplicatie1Click(Sender: TObject);
begin
  AboutBox1.show;
end;

procedure TFMForm.Creeazadirectornou1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TFMForm.BitBtn1Click(Sender: TObject);
begin
//  DirectoryOutline.Update;
  //DirectoryOutline.Show;
  //FileList.Directory := DirectoryOutline.Directory;
  //DirectoryPanel.caption := DirectoryOutline.Directory;
  //FMForm.refresh;
  //DirectoryOutline.update;
  ShellExecute(Handle,'open',pchar(cale_exec),nil,nil,SW_SHOWNORMAL);
  Application.Terminate;
  //shellexecute
end;

procedure TFMForm.Colturirotunjite1Click(Sender: TObject);
var
  rgn1:hRgn;
  rgn2:hRgn;
begin
  rgn1:=CreateEllipticRgn(0,0,FMForm.width,FMForm.height);
  SetWindowRgn(FMForm.Handle,rgn1,true);
  //rgn2:=CreateEllipticRgn(0,0,.Width,FMForm.Height);
  //SetWindowRgn(FMForm.Handle,rgn1,true);

end;

procedure TFMForm.Colturinormale1Click(Sender: TObject);
var
  rgn1:hRgn;
begin
  //rgn1:=CreateEllipticRgn(0,0,FMForm.width,FMForm.height);
  //SetWindowRgn(FMForm.Handle,rgn1,true);
  FMForm.Repaint;
end;

procedure TFMForm.Stergedirector1Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TFMForm.Editeazafisier1Click(Sender: TObject);
begin
  ShellExecute(Handle,'open',pchar(cale_notepad),pchar(FileList.FileName),nil,SW_SHOWNORMAL);
end;

procedure TFMForm.Editorimagini1Click(Sender: TObject);
begin
  ShellExecute(Handle,'open',pchar(cale_paint),nil,nil,SW_SHOWNORMAL);
end;

procedure TFMForm.ExploratorInternet1Click(Sender: TObject);
begin
   ShellExecute(Handle,'open',pchar(cale_explorer),nil,nil,SW_SHOWNORMAL);
end;

procedure TFMForm.Se1Click(Sender: TObject);
begin
  Form1.show;
end;

procedure TFMForm.Impacheteazafisier1Click(Sender: TObject);
begin
  ShellExecute(Handle,'open',pchar(cale_arhiv),pchar('a -s '+cale_pt_arhiv+' '+FileList.FileName),nil,SW_SHOWMINIMIZED);
end;

procedure TFMForm.Despacheteazafisier1Click(Sender: TObject);
begin
 Form4.Show;
 //ShellExecute(Handle,'open',pchar(cale_dezarhiv),pchar('a -s '+cale_pt_arhiv+'\arhfman.rar '+FileList.FileName),nil,SW_SHOWMINIMIZED);
end;

procedure TFMForm.FileListDblClick(Sender: TObject);
begin
  with FileList do
  begin
    if HasAttr(FileName, faDirectory) then
      DirectoryOutline.Directory := FileName
    else ExecuteFile(FileName, '', Directory, SW_SHOW);
  end;
end;

procedure CopyDirectoryTree(AHandle: THandle; const AFromDirectory, AToDirectory: String);
var
  SHFileOpStruct: TSHFileOpStruct;
  FromDir: PChar;
  ToDir: PChar;
begin

  GetMem(FromDir, Length(AFromDirectory)+2);
  try
    GetMem(ToDir, Length(AToDirectory)+2);
    try

      FillChar(FromDir^, Length(AFromDirectory)+2, 0);
      FillChar(ToDir^, Length(AToDirectory)+2, 0);

      StrCopy(FromDir, PChar(AFromDirectory));
      StrCopy(ToDir, PChar(AToDirectory));

      with SHFileOpStruct do
      begin
        Wnd    := AHandle;   // Assign the window handle
        wFunc  := FO_COPY;  // Specify a file copy
        pFrom  := FromDir;
        pTo    := ToDir;
        fFlags := FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION;
        fAnyOperationsAborted := False;
        hNameMappings := nil;
        lpszProgressTitle := nil;
        if SHFileOperation(SHFileOpStruct) <> 0 then
          RaiseLastWin32Error;
      end;
    finally
      FreeMem(ToDir, Length(AToDirectory)+2);
    end;
  finally
    FreeMem(FromDir, Length(AFromDirectory)+2);
  end;
end;

procedure TFMForm.Copieremultipla1Click(Sender: TObject);
var
   i,con:integer;
begin
//  FMForm.Caption:=DirectoryOutline.Directory;
  Form5.show;
 { //con:=0;
  for i:=0 to filelist.itemindex do
   if filelist.selected[i] then
    //con:=con+1;
  //showmessage(inttostr(con));}
end;

procedure TFMForm.FileListKeyPress(Sender: TObject; var Key: Char);
begin
  //con_fis:=con_fis+1;
  //fis[con_fis]:=filelist.FileName;
end;

procedure TFMForm.FileListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //con_fis:=con_fis+1;
  //fis[con_fis]:=filelist.FileName;
end;

procedure TFMForm.FileListClick(Sender: TObject);
begin
  //con_fis:=con_fis+1;
  //FileList.count
  //fis[con_fis]:=filelist.items[indice];
end;

procedure TFMForm.FileListEnter(Sender: TObject);
var
  i:integer;
begin
  //con_fis:=0;
  //i:=FileList.count;
  //Showmessage(inttostr(i));
end;

procedure TFMForm.Copieredirector1Click(Sender: TObject);
begin
 Form6.Caption:=Form6.Caption+' '+DirectoryOutline.Directory;
 Form6.Show;
end;

procedure TFMForm.Stergeredirector1Click(Sender: TObject);
begin
  Form7.Show;
end;

procedure TFMForm.Mutaredirector1Click(Sender: TObject);
begin
  Form8.Show;
end;

procedure TFMForm.Redenumiredirector1Click(Sender: TObject);
begin
  Form9.Show;
end;

procedure TFMForm.Split1Click(Sender: TObject);
begin
  Form10.Show;
end;

procedure Combina(Director,fisier:String);
var
inf,outf:file;
Buf: array[1..1024] of Char;
cititi,volcr:integer;
fisinit:string;
begin
volcr:=1;
if extractfileext(director+'\'+fisier)<>'.spl1' then begin
                                                       combina_ok:=false;
                                                       exit;
                                                end;
fisinit:=ChangeFileExt(director+'\'+fisier,'');
assignfile(outf,fisinit);
rewrite(outf,1);
while fileexists(fisinit+'.spl'+inttostr(volcr)) do
begin
assignfile(inf,fisinit+'.spl'+inttostr(volcr));
reset(inf,1);
while not eof(inf) do
        begin
        blockread(inf,buf,sizeof(buf),cititi);
        blockwrite(outf,buf,cititi);
        end;
inc(volcr);
closefile(inf);
end;
closefile(outf);

end;

procedure TFMForm.Combina1Click(Sender: TObject);
begin
 Combina(FMForm.FileList.Directory,FMForm.FileList.Items[FMForm.FileList.ItemIndex]);
 if combina_ok
 then
     ShowMessage('Operatie incheiata cu succes.')
 else
 begin
     ShowMessage('Eroare! Selectati fisierul <.spl1>');
     combina_ok:=true;
 end;
end;

end.
